#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#define  INCL_PM
#include <os2.h>

#include "ezapp.h"

#define  MRFALSE MRFROMSHORT( FALSE )
#define  MRTRUE  MRFROMSHORT( TRUE )
#define  MRZERO  MRFROMSHORT( 0 )

MRESULT EXPENTRY
EZAppDlgProc( HWND   hwnd,
              ULONG  msg,
              MPARAM mp1,
              MPARAM mp2  )
/*************************/
{
   static HWND hmenu = NULLHANDLE;

   switch ( msg )
   {
      case WM_INITDLG:
         {
            USHORT   usResID;
            HAB      hab;
            HPOINTER hicon;
            HACCEL   haccel;

            usResID = WinQueryWindowUShort( hwnd, QWS_ID );

            /* attach the menu, if any */
            hmenu = WinLoadMenu( hwnd, NULLHANDLE, usResID );
            if ( hmenu != NULLHANDLE )
            {
               WinSendMsg( hwnd, WM_UPDATEFRAME, MPFROMLONG( FID_MENU ), MPVOID );
            }

            /* attach the icon, if any */
            hicon = WinLoadPointer( HWND_DESKTOP, NULLHANDLE, usResID );
            if ( hicon != NULLHANDLE )
            {
               WinSendMsg( hwnd, WM_SETICON, MPFROMLONG( hicon ), MPVOID );
            }

            /* attach the accelerator table, if any */
            hab    = WinQueryAnchorBlock( hwnd );
            haccel = WinLoadAccelTable( hab, NULLHANDLE, usResID );
            if ( haccel != NULLHANDLE )
            {
               WinSetAccelTable( hab, haccel, hwnd );
            }
         }
         return ( MRFALSE );

      case WM_COMMAND:
         {
            USHORT usID;

            switch ( usID = SHORT1FROMMP( mp1 ))
            {
               case IDM_EXIT:
                  {
                     WinDismissDlg( hwnd, 1 );
                  }
                  break;
            }
         }
         return ( MRZERO );
   }

   return ( WinDefDlgProc( hwnd, msg, mp1, mp2 ));
}

int
main( void )
/**********/
{
   HAB hab;

   hab = WinInitialize( 0 );
   if ( hab != NULLHANDLE )
   {
      HMQ hmq;

      /*
       * Technically, we shouldn't need this, but strange shit happens occasionally
       * if we don't create a message queue specifically.
       */
      hmq = WinCreateMsgQueue( hab, 0 );
      if ( hmq != NULLHANDLE )
      {
         HWND hwnd;

         /*
          * Note that we're assuming the resource ID is in DLG_EZAPP!
          */
         hwnd = WinLoadDlg( HWND_DESKTOP, NULLHANDLE, EZAppDlgProc, NULLHANDLE, DLG_EZAPP, NULL );
         if ( hwnd != NULLHANDLE )
         {
            WinProcessDlg( hwnd );

            /*
             * WinProcessDlg() does NOT destroy the window on return! Do it here,
             * otherwise the window procedure won't ever get a WM_DESTROY,
             * which we may want :-)
             */
            WinDestroyWindow( hwnd );
         }

         WinDestroyMsgQueue( hmq );
      }

      WinTerminate( hab );
   }

   return ( 0 );
}
