#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#define  INCL_PM
#include <os2.h>

#include "ezframe.h"

#define  MRFALSE MRFROMSHORT( FALSE )
#define  MRTRUE  MRFROMSHORT( TRUE )
#define  MRZERO  MRFROMSHORT( 0 )

MRESULT EXPENTRY
EZFrameWndProc( HWND   hwnd,
                ULONG  msg,
                MPARAM mp1,
                MPARAM mp2  )
/***************************/
{
   switch ( msg )
   {
      case WM_CREATE:
         {
         }
         return ( MRZERO );

      case WM_PAINT:
         {
            HPS   hps;
            RECTL rcl;
            ULONG ulFound;
            COLOR color;

            color = CLR_WHITE; /* just in case this fails */
            WinQueryPresParam( hwnd, PP_BACKGROUNDCOLORINDEX, 0, &ulFound,
                               sizeof( color ), &color, 0 );

            hps = WinBeginPaint( hwnd, NULLHANDLE, &rcl );

            WinFillRect( hps, &rcl, color );

            WinEndPaint( hps );
         }
         return ( MRZERO );

      case WM_COMMAND:
         {
            USHORT usID;

            switch ( usID = SHORT1FROMMP( mp1 ))
            {
               case IDM_EXIT:
                  {
                     WinSendMsg( hwnd, WM_CLOSE, MPVOID, MPVOID );
                  }
                  break;
            }
         }
         return ( MRZERO );
   }

   return ( WinDefWindowProc( hwnd, msg, mp1, mp2 ));
}

int
main( void )
/**********/
{
   HAB hab;

   hab = WinInitialize( 0 );
   if ( hab != NULLHANDLE )
   {
      HMQ hmq;

      /*
       * Technically, we shouldn't need this, but strange shit happens occasionally
       * if we don't create a message queue specifically.
       */
      hmq = WinCreateMsgQueue( hab, 0 );
      if ( hmq != NULLHANDLE )
      {
         HWND hwnd;

         WinRegisterClass( hab, WC_EZFRAME, EZFrameWndProc, 0, sizeof( ULONG ) * 2 );

         /*
          * Note that we're assuming the resource ID is in DLG_EZAPP!
          */
         hwnd = WinLoadDlg( HWND_DESKTOP, NULLHANDLE, NULL, NULLHANDLE,
                            WIN_EZFRAME, NULL );
         if ( hwnd != NULLHANDLE )
         {
            QMSG     qmsg;
            RECTL    rcl;
            HPOINTER hicon;
            HACCEL   haccel;
            HWND     hmenu;

            /* attach the menu, if any */
            hmenu = WinLoadMenu( hwnd, NULLHANDLE, WIN_EZFRAME );
            if ( hmenu != NULLHANDLE )
            {
               WinSendMsg( hwnd, WM_UPDATEFRAME, MPFROMLONG( FID_MENU ), MPVOID );
            }

            /* attach the icon, if any */
            hicon = WinLoadPointer( HWND_DESKTOP, NULLHANDLE, WIN_EZFRAME );
            if ( hicon != NULLHANDLE )
            {
               WinSendMsg( hwnd, WM_SETICON, MPFROMLONG( hicon ), MPVOID );
            }

            /* attach the accelerator table, if any */
            haccel = WinLoadAccelTable( hab, NULLHANDLE, WIN_EZFRAME );
            if ( haccel != NULLHANDLE )
            {
               WinSetAccelTable( hab, haccel, hwnd );
            }

            /* size/position the client window */
            WinQueryWindowRect( hwnd, &rcl );
            WinCalcFrameRect( hwnd, &rcl, TRUE );

            WinSetWindowPos( WinWindowFromID( hwnd, FID_CLIENT ), HWND_TOP, rcl.xLeft,
                             rcl.yBottom, rcl.xRight - rcl.xLeft, 
                             rcl.yTop - rcl.yBottom, SWP_MOVE | SWP_SIZE | SWP_ZORDER );

            while ( WinGetMsg( hab, &qmsg, NULLHANDLE, 0, 0 ))
            {
               WinDispatchMsg( hab, &qmsg );
            }

            WinDestroyWindow( hwnd );
         }

         WinDestroyMsgQueue( hmq );
      }

      WinTerminate( hab );
   }

   return ( 0 );
}
